note
	description: "Forest fire graphical application."
	author: "Generated by the New Vision2 Application Wizard."
	date: "$Date: 2013/12/10 15:41:12 $"
	revision: "1.0.0"

class
	APPLICATION

inherit

	EV_APPLICATION

create
	make_and_launch

feature {NONE} -- Initialization

	make_and_launch
			-- Initialize and launch the application.
		do
			default_create
			prepare
			launch
		end

	prepare
			-- Prepare the first window to be displayed.
		do
				-- Create and initialize the main window.
			create main_window

				-- Create the renderer and make it render in the main window.
			create forest_renderer.make_with_window (main_window)

				-- Create the input handler to start the the animation when when the user presses the enter key.
			create input_handler.make
			input_handler.accelerator_enter.actions.extend (agent start)
			main_window.accelerators.extend (input_handler.accelerator_enter)
			main_window.show
		end

	wait_ms (n: INTEGER)
			-- Wait `n' milliseconds.
			-- (stolen secretly from traffic)
		local
			stopwatch: DT_STOPWATCH
			application: EV_APPLICATION
		do
			create stopwatch.make
			application := (create {EV_ENVIRONMENT}).application
			from
				stopwatch.start
			until
				stopwatch.elapsed_time.millisecond >= n or application.is_destroyed
			loop
				application.process_events
			end
		end

	start
			-- Start the main loop.
		do
			from
			until
				is_destroyed
			loop
				wait_ms (Step_duration_ms)
				forest_renderer.render_step
			end
		end

feature {NONE} -- Implementation

	main_window: MAIN_WINDOW

	forest_renderer: FOREST_RENDERER

	input_handler: INPUT_HANDLER
			-- Handler for user input (only the enter key for this application)

	Step_duration_ms: INTEGER = 500
			-- the step duration in milliseconds, after which a new state of the forest is created.

end -- class APPLICATION
